sub duplo_ui_ui_ui()
 REM		$Id$
 REM	Copyright (c) New Deal 1997 -- All Rights Reserved
 REM	FILE:		STDINC.BH

 STRUCT TimeOfDay
  DIM hour as integer
  DIM minute as integer
  DIM second as integer
 END STRUCT

 STRUCT Date
  DIM year as integer
  DIM month as integer
  DIM day as integer
 END STRUCT

 STRUCT Notification
  DIM arg1 as integer
  DIM arg2 as integer
  DIM arg3 as integer
  DIM arg4 as integer
  DIM arg5 as string
  DIM arg6 as complex
 END STRUCT

REM useful color constants
CONST WHITE 		&Hffffffff
CONST BLACK 		&Hff000000
CONST GRAY_50 		&Hff808080, GREY_50 		&Hff808080
CONST DARK_GRAY 	&Hff555555, LIGHT_GRAY		&Hffaaaaaa
CONST DARK_GREY 	&Hff555555, LIGHT_GREY		&Hffaaaaaa
CONST DARK_GREEN	&Hff00aa00, LIGHT_GREEN 	&Hff55ff55
CONST DARK_BLUE 	&Hff0000aa, LIGHT_BLUE		&Hff5555ff
CONST DARK_CYAN		&Hff00aaaa, LIGHT_CYAN		&Hff55ffff
CONST DARK_PURPLE	&Hffaa00aa, LIGHT_PURPLE	&Hffff55ff
CONST DARK_RED		&Hffaa0000, LIGHT_RED		&Hffff5555
CONST BROWN		&Hffaa5500, YELLOW		&Hffffff55

REM useful text style constants
CONST UNDERLINE		1
CONST STRIKE_THRU	2
CONST SUBSCRIPT		4
CONST SUPERSCRIPT	8
CONST ITALIC		16
CONST BOLD		32

REM useful Boolean constants
CONST TRUE		1
CONST FALSE		0

REM sound constants
CONST SS_ERROR		0
CONST SS_WARNING	1
CONST SS_NOTIFY		2
CONST SS_NO_INPUT	3
CONST SS_KEY_CLICK	4
CONST SS_ALARM		5

CONST MOUSE_PRESS 1, MOUSE_HOLD 2, MOUSE_DRAG 3, MOUSE_TO 4, MOUSE_RELEASE 5
CONST MOUSE_LOST 6, MOUSE_FLY_OVER 7

CONST C_SYS_00			&Hff00
CONST C_SYS_FF			&Hffff
CONST C_SYS_BACKSPACE		&Hff08
CONST C_SYS_TAB			&Hff09
CONST C_SYS_ENTER		&Hff0d
CONST C_SYS_ESCAPE		&Hff1b
CONST C_SYS_F1			&Hff80
CONST C_SYS_F2			&Hff81
CONST C_SYS_F3			&Hff82
CONST C_SYS_F4			&Hff83
CONST C_SYS_F5			&Hff84
CONST C_SYS_F6			&Hff85
CONST C_SYS_F7			&Hff86
CONST C_SYS_F8			&Hff87
CONST C_SYS_F9			&Hff88
CONST C_SYS_F10			&Hff89
CONST C_SYS_F11			&Hff8a
CONST C_SYS_F12			&Hff8b
CONST C_SYS_F13			&Hff8c
CONST C_SYS_F14			&Hff8d
CONST C_SYS_F15			&Hff8e
CONST C_SYS_F16			&Hff8f
CONST C_SYS_UP			&Hff90
CONST C_SYS_DOWN		&Hff91
CONST C_SYS_RIGHT		&Hff92
CONST C_SYS_LEFT		&Hff93
CONST C_SYS_HOME		&Hff94
CONST C_SYS_END			&Hff95
CONST C_SYS_PREVIOUS		&Hff96
CONST C_SYS_NEXT		&Hff97
CONST C_SYS_INSERT		&Hff98
CONST C_SYS_CLEAR		&Hff99	rem Not used in Geos.
CONST C_SYS_DELETE		&Hff9a
CONST C_SYS_PRINT_SCREEN	&Hff9b
CONST C_SYS_HELP		&Hff9d	rem Not used in Geos.
CONST C_SYS_BREAK		&Hff9e
CONST C_SYS_CAPS_LOCK		&Hffe8
CONST C_SYS_NUM_LOCK		&Hffe9
CONST C_SYS_SCROLL_LOCK		&Hffea
CONST C_SYS_LEFT_ALT		&Hffe0
CONST C_SYS_RIGHT_ALT		&Hffe1
CONST C_SYS_LEFT_CTRL		&Hffe2
CONST C_SYS_RIGHT_CTRL		&Hffe3
CONST C_SYS_LEFT_SHIFT		&Hffe4
CONST C_SYS_RIGHT_SHIFT		&Hffe5


CONST KEY_BS 		&Hff08
CONST KEY_DEL 		&Hff9a
CONST KEY_ENTER 	&Hff0d
CONST KEY_KP_RETURN 	&Hffff
CONST KEY_HOME		&Hff94
CONST KEY_TAB		&Hff09
CONST KEY_END		&Hff93
CONST KEY_ESC		&Hff1b
CONST KEY_UP_ARROW	&Hff90
CONST KEY_LEFT_ARROW	&Hff93
CONST KEY_RIGHT_ARROW	&Hff92
CONST KEY_DOWN_ARROW	&Hff91

REM date formats
CONST DTF_LONG				0
CONST DTF_LONG_CONDENSED		1
CONST DTF_LONG_NO_WEEKDAY		2
CONST DTF_LONG_NO_WEEKDAY_CONDENSED	3
CONST DTF_SHORT				4
CONST DTF_ZERO_PADDED_SHORT		5
CONST DTF_MD_LONG			6
CONST DTF_MD_LONG_NO_WEEKDAY		7
CONST DTF_MD_SHORT			8
CONST DTF_MY_LONG			9
CONST DTF_MY_SHORT			10
CONST DTF_YEAR				11
CONST DTF_MONTH				12
CONST DTF_DAY				13
CONST DTF_WEEKDAY			14
REM time formats
CONST DTF_HMS				15
CONST DTF_HM				16
CONST DTF_H				17
CONST DTF_MS				18
CONST DTF_HMS_24HOUR			19
CONST DTF_HM_24HOUR			20

REM pi
CONST PI 3.14159265359

REM Format() constants
CONST FFAF_SCIENTIFIC		&H100
CONST FFAF_PERCENT		&H80
CONST FFAF_USE_COMMAS		&H40
CONST FFAF_NO_TRAIL_ZEROS	&H20
CONST FFAF_NO_LEAD_ZERO		&H10

REM dim system as module
REM system = SystemModule()

 REM end of stdinc.bh

DisableEvents()
Dim form1 as form
form1 = MakeComponent("form","app")
CompInit form1
proto="form1"
top=87
left=119
tileVInset=5
tileHInset=5
tile=1
caption="Lauflicht und so"
tileSpacing=5
End CompInit
Dim group1 as group
group1 = MakeComponent("group",form1)
CompInit group1
proto="group1"
caption=""
look=1
tile=1
sizeHControl=0
sizeVControl=3
width=158
tileLayout=1
visible=1
End CompInit
Dim label1 as label
label1 = MakeComponent("label",group1)
CompInit label1
proto="label1"
caption=""
sizeHControl=0
sizeVControl=0
width=10
height=10
visible=1
End CompInit
label1.name="label1"
Dim label2 as label
label2 = MakeComponent("label",group1)
CompInit label2
proto="label2"
caption=""
sizeHControl=0
sizeVControl=0
width=10
height=10
visible=1
End CompInit
label2.name="label2"
Dim label3 as label
label3 = MakeComponent("label",group1)
CompInit label3
proto="label3"
caption=""
sizeHControl=0
sizeVControl=0
width=10
height=10
visible=1
End CompInit
label3.name="label3"
Dim label4 as label
label4 = MakeComponent("label",group1)
CompInit label4
proto="label4"
caption=""
sizeHControl=0
sizeVControl=0
width=10
height=10
visible=1
End CompInit
label4.name="label4"
Dim label5 as label
label5 = MakeComponent("label",group1)
CompInit label5
proto="label5"
caption=""
sizeHControl=0
sizeVControl=0
width=10
height=10
visible=1
End CompInit
label5.name="label5"
Dim label6 as label
label6 = MakeComponent("label",group1)
CompInit label6
proto="label6"
caption=""
sizeHControl=0
sizeVControl=0
width=10
height=10
visible=1
End CompInit
label6.name="label6"
Dim label7 as label
label7 = MakeComponent("label",group1)
CompInit label7
proto="label7"
caption=""
sizeHControl=0
sizeVControl=0
width=10
height=10
visible=1
End CompInit
label7.name="label7"
Dim label8 as label
label8 = MakeComponent("label",group1)
CompInit label8
proto="label8"
caption=""
sizeHControl=0
sizeVControl=0
width=10
height=10
visible=1
End CompInit
label8.name="label8"
group1.name="group1"
Dim lauf_button as button
lauf_button = MakeComponent("button",form1)
CompInit lauf_button
proto="lauf_button"
caption="Lauflicht (1x)"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
lauf_button.name="lauf_button"
Dim kit_button as button
kit_button = MakeComponent("button",form1)
CompInit kit_button
proto="kit_button"
caption="K.I.T."
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
kit_button.name="kit_button"
Dim testm_button as button
testm_button = MakeComponent("button",form1)
CompInit testm_button
proto="testm_button"
caption="Testmodus"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
testm_button.name="testm_button"
Dim test_group as group
test_group = MakeComponent("group",form1)
CompInit test_group
proto="test_group"
caption="Testmodus"
look=1
tile=1
sizeHControl=3
sizeVControl=0
height=63
tileSpacing=5
visible=1
End CompInit
Dim number1 as number
number1 = MakeComponent("number",test_group)
CompInit number1
proto="number1"
caption=""
sizeHControl=0
sizeVControl=3
width=30
maximum=255
visible=1
End CompInit
number1.name="number1"
Dim test_button as button
test_button = MakeComponent("button",test_group)
CompInit test_button
proto="test_button"
caption="Test !"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
test_button.name="test_button"
test_group.name="test_group"
form1.width=190
form1.height=205
form1.name="form1"
Dim timer1 as timer
timer1 = MakeComponent("timer","app")
CompInit timer1
proto="timer1"
interval=5
End CompInit
timer1.name="timer1"
Dim timer2 as timer
timer2 = MakeComponent("timer","app")
CompInit timer2
proto="timer2"
interval=5
End CompInit
timer2.name="timer2"
EnableEvents()
duplo_start()
end sub

sub duplo_start()
REM place initialization code here

Auswertung(number1.value)	rem Wertuebergabe Number-Objekt -> Variable
dim laufwert as integer
laufwert = 128
dim kitwert as integer
kitwert = 128
dim kitrichtung as string
kitrichtung = "r"
testm_button_pressed(testm_button)
end sub

sub module_goTo(context as string)

end sub

function module_getContext()

module_getContext = ""

end function

sub module_show()
REM code for making this module appear
form1.visible=1

end sub

sub module_hide()
REM code for making this module disappear
form1.visible=0

end sub

sub module_exit()

end sub

sub Auswertung(wert as integer)

rem Funktion zur Auswertung des des im Number-Objekt eingestellten Wertes,
rem wird durch Druck auf Taste [Test!] oder bei Aenderung der Zahl aufgerufen

label1.caption = "-"		rem Label "leeren"
label2.caption = "-"
label3.caption = "-"
label4.caption = "-"
label5.caption = "-"
label6.caption = "-"
label7.caption = "-"
label8.caption = "-"

if wert >= 128			rem Number1-Wert auswerten und bei Uebereinstimmung
 wert=wert-128			rem um den entspechenden Wert verringern
 label1.caption = "X"	rem wenn die Bedingung erfuellt wird, Ausgabe "X" in
end if						rem dem dazugehoerigen Label.

if wert >= 64
 wert=wert-64
 label2.caption = "X"
end if

if wert >= 32
 wert=wert-32
 label3.caption = "X"
end if

if wert >= 16
 wert=wert-16
 label4.caption ="X"
end if

if wert >=8
 wert=wert-8
 label5.caption ="X"
end if

if wert>=4
 wert=wert-4
 label6.caption ="X"
end if

if wert>=2
 wert=wert-2
 label7.caption ="X"
end if

if wert=1
 label8.caption ="X"
end if

end sub

sub number1_changed(self as number, value as integer)

Auswertung(number1.value)

rem Aufruf der Funktion zur Auswertung, mit Wertuebergabe

end sub

sub lauf_button_pressed(self as button)
	timer2.enabled = 0
	timer1.enabled = 1
	lauf_button.enabled = 0
	test_group.enabled = 0
	testm_button.enabled = 1
	kit_button.enabled = 1
end sub

sub timer1_ring(self as timer)

number1.value = laufwert
test_button_pressed(test_button)

if laufwert > 1
	laufwert = laufwert/2
else
	laufwert = 128
end if

end sub

sub kit_button_pressed(self as button)
	timer1.enabled = 0
	timer2.enabled = 1
	kit_button.enabled = 0
	test_group.enabled = 0
	lauf_button.enabled = 1
	testm_button.enabled = 1	
end sub

sub timer2_ring(self as timer)

number1.value = kitwert
test_button_pressed(test_button)

if kitrichtung = "r"
	if kitwert > 1
		kitwert = kitwert/2
	else
		kitrichtung = "l"
	end if
end if

if kitrichtung = "l"
	if kitwert < 128
		kitwert = kitwert*2
	else
		kitrichtung = "r"
	end if
end if

end sub

sub testm_button_pressed(self as button)
	timer2.enabled = 0
	timer1.enabled = 0
	testm_button.enabled = 0
	test_group.enabled = 1
	lauf_button.enabled = 1
	kit_button.enabled = 1	
end sub

sub test_button_pressed(self as button)

Auswertung(number1.value)
rem Aufruf der Funktion zur Auswertung, mit Wertuebergabe

end sub

